/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
import org.apache.directory.groovyldap.LDAP

ldap = LDAP.newInstance('ldap://magritte:389/')

FILTER_GROUPS = '(&(objectClass=groupOfNames)(member={0}))'
FILTER_USERS =  '(&(objectClass=person)(uid={0}))'
BASE_GROUPS = 'ou=gruppen,dc=bundestag,dc=de'
BASE_USERS = 'ou=personen,dc=bundestag,dc=de'

uid = args[0]

//Eintrag zum User ermitteln
userEntry = ldap.searchUnique(base: BASE_USERS, filter: FILTER_USERS, filterArgs: uid)
if (! userEntry) {
  println "User ${uid} not found"
  return
}

//Algorithmus, Schritt 1
def memberships = [] as Set
ldap.eachEntry( base: BASE_GROUPS, 
    filter: FILTER_GROUPS, 
    filterArgs: userEntry.dn) 
{ entry ->
  memberships += entry.dn
}

def newGroups = [] as Set
newGroups += memberships

// Algorithmus, Schritt 2+3
while (newGroups) {
  temp = [] as Set
  newGroups.each { groupDN ->
    ldap.eachEntry( base: BASE_GROUPS, 
        filter: FILTER_GROUPS, 
        filterArgs: groupDN) 
    { entry ->
      temp += entry.dn
      memberships += entry.dn
    }                               
  }
  newGroups = temp
}

memberships.each {
   println it  
}
