/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
import javax.naming.*
import javax.naming.directory.*

FILTER_USERS = '(&(objectClass=person)(uid={0}))'
FILTER_GROUPS = '(&(objectClass=groupOfNames)(member={0}))'
BASE_USERS = 'ou=personen,dc=bundestag,dc=de'
BASE_GROUPS = 'ou=gruppen,dc=bundestag,dc=de'

uid = args[0]

sub = new SearchControls(searchScope: 
    SearchControls.SUBTREE_SCOPE)

env = [
'java.naming.factory.initial': 'com.sun.jndi.ldap.LdapCtxFactory',
'java.naming.provider.url': 'ldap://magritte:389/'
] as Hashtable

ctx = new InitialDirContext(env)

//Eintrag zum User ermitteln
def String[] filterArgs = [ uid ]
results = ctx.search(BASE_USERS, FILTER_USERS, filterArgs, sub)
if (!results.hasMoreElements()) {
  return
}
userEntry = results.next()

// Algorithmus, Schritt 1
def memberships = [] as Set
filterArgs = [ userEntry.nameInNamespace ]
results = ctx.search(BASE_GROUPS, FILTER_GROUPS, filterArgs, sub)
results.each { entry ->
  memberships += entry.nameInNamespace
}

def newGroups = [] as Set
newGroups += memberships

// Algorithmus, Schritt 2+3
while (newGroups) {
  temp = [] as Set
  newGroups.each { groupDN ->
    filterArgs = [ groupDN ]
    results = ctx.search(BASE_GROUPS, FILTER_GROUPS, filterArgs, sub);
    results.each { entry ->
      if (! memberships.contains(entry.nameInNamespace)) {
        temp += entry.nameInNamespace
        memberships += entry.nameInNamespace
      }
    }
  }
  newGroups = temp
}

memberships.each {
  println it  
}
