/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
import org.apache.directory.groovyldap.LDAP

ldap = LDAP.newInstance('ldap://magritte:389', 
    'cn=Manager,dc=magritte' ,'secret')

dn = 'cn=Paul Panther,ou=personen,dc=bundestag,dc=de'

assert !ldap.exists(dn)

// Definiere Attribute als Map
attrs = [
  objectclass: ['top', 'person'],              
  sn: 'Panther',
  cn: 'Paul Panther'
]
ldap.add(dn, attrs)

assert ldap.exists(dn)