/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
package ldapbuch.kapitel5.spring;

import java.util.Properties;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.naming.directory.InitialDirContext;

import org.springframework.jndi.JndiTemplate;

/**
 * JndiTemplate, das mit DirContext arbeitet -- (Listing 5_12).
 * 
 * @author Stefan Z&ouml;rner
 */
public class DirContextJndiTemplate extends JndiTemplate {
  protected Context createInitialContext() throws NamingException {
    Properties env = this.getEnvironment();
    return new InitialDirContext(env);
  }
}