/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
package ldapbuch.kapitel5.spring;

import javax.naming.Binding;
import javax.naming.Context;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.DirContext;

import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jndi.JndiCallback;
import org.springframework.jndi.JndiTemplate;

/**
 * JndiCallback, ausgefhrt durch JndiTemplate -- (Listing 5_12).
 * 
 * @author Stefan Z&ouml;rner
 */
public class JndiTemplateDemo {

  @SuppressWarnings("resource")
  public static void main(String[] args) throws NamingException {

    BeanFactory bf = new ClassPathXmlApplicationContext(
        "ldapbuch/kapitel5/spring/jndiTemplate.xml");

    JndiTemplate template = (JndiTemplate) bf
        .getBean("jndiTemplate");

    JndiCallback<?> callback = new JndiCallback<Object>() {

      public Object doInContext(Context ctx)
          throws NamingException {
        DirContext dctx = (DirContext) ctx;
        NamingEnumeration<Binding> elements = dctx
            .listBindings("");
        while (elements.hasMore()) {
          System.out
              .println(elements.next().getNameInNamespace());
        }
        return null;
      }
    };

    template.execute(callback);
  }
}
