/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
package ldapbuch.kapitel5.spring;

import javax.naming.NamingException;
import javax.naming.directory.DirContext;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jndi.JndiTemplate;

/**
 * Ein Lookup mit dem JndiTemplate von Spring -- (Listing 5_11).
 * 
 * @author Stefan Z&ouml;rner
 */
public class JndiTemplateLookup {

  public static void main(String[] args) throws NamingException {

    ApplicationContext appCtx = new ClassPathXmlApplicationContext(
        "ldapbuch/kapitel5/spring/jndiTemplate.xml");

    JndiTemplate template = (JndiTemplate) appCtx
        .getBean("jndiTemplate");

    DirContext dc = (DirContext) template
        .lookup("uid=amerkel,ou=personen");
    System.out.println(dc.getAttributes("").get("cn").get());
  }
}
