/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
package ldapbuch.kapitel5.spring;

import javax.naming.NamingException;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * Verwendung des DAOs, siehe Seite 193.
 * 
 * @author Stefan Z&ouml;rner
 */
public class LdapTemplateDaoDemo {

  public static void main(String[] args)
      throws InterruptedException, NamingException {

    ApplicationContext appCtx = new ClassPathXmlApplicationContext(
        "ldapbuch/kapitel5/spring/ldapTemplate.xml");

    PolitikerDao dao = (PolitikerDao) appCtx.getBean("politikerDao");
    Politiker p = dao.getPolitikerByKennung("amerkel");
    System.out.println(p);
  }
}
