/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
package ldapbuch.kapitel5.spring;

import java.util.List;

import javax.naming.NamingException;
import javax.naming.directory.SearchControls;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.ldap.core.AttributesMapper;
import org.springframework.ldap.core.LdapTemplate;

/**
 * Verwendung des Mappings -- (Listing 5_16).
 * 
 * @author Stefan Z&ouml;rner
 */
public class LdapTemplateDemo {

  @SuppressWarnings("unchecked")
  public static void main(String[] args)
      throws InterruptedException, NamingException {

    ApplicationContext appCtx = new ClassPathXmlApplicationContext(
        "ldapbuch/kapitel5/spring/ldapTemplate.xml");

    LdapTemplate template = (LdapTemplate) appCtx
        .getBean("ldapTemplate");

    AttributesMapper map = new RfcCompliantPolitikerAttrMapper();
    List<Politiker> l = template.search("",
        "(&(objectclass=person)(sn~=Schmidt)(!(mail=*)))",
        SearchControls.SUBTREE_SCOPE, map);
    for (Politiker p : l) {
      System.out.println(p);
    }
  }
}
