/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
package ldapbuch.kapitel5.spring;

import java.text.MessageFormat;
import java.util.List;

import javax.naming.directory.SearchControls;

import org.springframework.ldap.core.AttributesMapper;
import org.springframework.ldap.core.LdapTemplate;

/**
 * Einfache Implementierung fuer das DAO.
 * 
 * @author Stefan Z&ouml;rner
 */
public class PolitikerDaoImpl implements PolitikerDao {
	
	private LdapTemplate ldapTemplate;
	private String ldapFilter;
	private AttributesMapper attrMapper;
	
	public void setAttrMapper(AttributesMapper attrMapper) {
		this.attrMapper = attrMapper;
	}

	public void setLdapFilter(String userFilter) {
		this.ldapFilter = userFilter;
	}

	public void setLdapTemplate(LdapTemplate ldapTemplate) {
    this.ldapTemplate = ldapTemplate;
  }
	
	/* (non-Javadoc)
   * @see ldapbuch.kapitel5.spring.PolitikerDao#getUserById(java.lang.String)
   */
	public Politiker getPolitikerByKennung(String kennung) {
    
    String filter = MessageFormat.format(ldapFilter, new Object[] { kennung });
    
    @SuppressWarnings("unchecked")
    List<Politiker> l = ldapTemplate.search("", filter, SearchControls.SUBTREE_SCOPE, attrMapper);
    
		return l.get(0);
	}
}
