/* Beispiele aus dem Buch "LDAP fuer Java-Entwickler", 
 * Stefan Zoerner, 4. aktualisierte Auflage 2013
 *  
 * Webseite zum Buch: http://www.ldapjava.de/ 
 * Software & Support Media GmbH / entwickler.press, http://www.entwickler-press.de/
 */
package ldapbuch.kapitel5.spring;

import javax.naming.NamingException;
import javax.naming.directory.Attributes;

import org.springframework.ldap.core.AttributesMapper;

/**
 * Komponente zum Mappen von Attributwerten auf Politikerobjekte -- (Listing 5_15).
 * 
 * @author Stefan Z&ouml;rner
 */
public class RfcCompliantPolitikerAttrMapper implements
    AttributesMapper {

  public Object mapFromAttributes(Attributes attrs)
      throws NamingException {

    Politiker p = new Politiker();
    String uid = attrs.get("uid").get(0).toString();
    String cn = attrs.get("cn").get(0).toString();

    p.setBenutzerKennung(uid);
    p.setVollstName(cn);

    return p;
  }
}